
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/init.h>
#include <linux/delay.h>
#include <linux/irq.h>
#include <linux/poll.h>
#include <linux/cdev.h>
#include <linux/device.h>
#include <asm/io.h>

#include <linux/mm.h>//remap_pfn_range 

/* 豸 */
#define BSP_DEV_MAJOR               0
/* 豸 */
#define BSP_DEV_NAME                "mem_dump"

/* ģغ */
static int osp_mem_init(void);
/* ģжغ */
static void osp_mem_exit(void);
/* 豸 */
int mem_bsp_open(struct inode *inode, struct file *filp);
/* ͷ豸 */
int mem_bsp_release(struct inode *inode, struct file *filp);
/*  */
static ssize_t mem_bsp_read (struct file *filp, __user char *buf, size_t count, loff_t *f_pos);
/* ioctl */
long mem_bsp_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
/* mmap */
int mem_bsp_mmap(struct file *filp, struct vm_area_struct *vma);
/* д */
ssize_t mem_bsp_write(struct file *filp, const char *buf, size_t count, loff_t *f_pos);



/******************************* ֲ궨 ***********************************/
/* bsp 豸 */


typedef struct mem_struct{
	int g_s32BspDevMajor ;
	unsigned int g_u32CacheCoherent;
	struct cdev g_struBspDev;
	struct class *cls;
	dev_t g_devno;
	struct device *parent;
	struct device *this_device;

}mem_st;


/******************************* ʵ *************************************/
/*******************************************************************************
* : mem_init
* :   ģʱں
* ĵ:
* 洢:int
* : 
* ֵ:
* 0       ɹ
* <0      ʧ
* ˵ʧܲοLinuxϢͷļ
*******************************************************************************/

static mem_st mem_dev ={
	.g_s32BspDevMajor = 0,
	.g_u32CacheCoherent = 0,
	.g_devno = 0,
	

};

static struct file_operations g_struBspOp = {
	.owner   = THIS_MODULE,
	.read    = mem_bsp_read,
	.write    = mem_bsp_write,
	.open    = mem_bsp_open,
	.release = mem_bsp_release,
	.mmap    = mem_bsp_mmap,
    .unlocked_ioctl = mem_bsp_ioctl,
};

static int osp_mem_init(void)
{
    /*ý*/
    int result;
    /*豸*/
    dev_t devno;

    printk("bsp_init.\n");
  
    /* ȡ豸 */
    if (0 == mem_dev.g_s32BspDevMajor)
    {
        /* 豸 */
        result = alloc_chrdev_region(&devno, 0, 1, BSP_DEV_NAME);

        /* жϷֵ */
        if (result < 0)
        {
            printk(KERN_WARNING "bsp: alloc_chrdev_region error! errno = %d\n", result);
            return result;
        }
		mem_dev.g_devno = devno;
        /* 豸Ϣ */
        mem_dev.g_s32BspDevMajor = MAJOR(devno);

        /* ʼdev */
        cdev_init(&(mem_dev.g_struBspDev), &g_struBspOp);
        /* 豸devӦֵ */
        mem_dev.g_struBspDev.owner = THIS_MODULE;
        mem_dev.g_struBspDev.ops = &g_struBspOp;
        /* ϵͳdev豸 */
        result = cdev_add(&mem_dev.g_struBspDev, devno, 1);
        if (result < 0)
        {
            printk ("cdev_add error!errno = %d", result);
        }
		
	//	ret = device_create_file(ucp_smem_miscdev.this_device, &dev_attr_ucp_smem);
        mem_dev.cls = class_create(THIS_MODULE, "mem_dump");
		device_create(mem_dev.cls, NULL, devno, NULL, "mem_dump");
		
        printk("bsp module init success!\n");
        /* سɹ */
        return 0;
    }
    else
    {
        printk("bsp module already init!\n");
        /*  */
        return -EBUSY;
    }
}

/*******************************************************************************
* : ad9371_exit
* :  ģжغ
* ĵ:
* 洢:void
* : 
* ֵ: 
* ˵
*******************************************************************************/
static void osp_mem_exit(void)
{
    /* жǷִйģ */
    if(mem_dev.g_s32BspDevMajor > 0)
    {
        /* ɾַ豸 */
		device_destroy(mem_dev.cls, mem_dev.g_devno);
		class_destroy(mem_dev.cls);
        cdev_del(&(mem_dev.g_struBspDev));
        /* ͷѷĿռ */
        unregister_chrdev_region(MKDEV(mem_dev.g_s32BspDevMajor, 0), 1);
        /* 豸 */
        mem_dev.g_s32BspDevMajor = 0;
        /* Ϣ */
        printk("bsp module cleanup success!\n");

    }
    return;
}

/*******************************************************************************
* : ad9731_bsp_open
* : ļ
* ĵ:
* 洢:int
* :
*
*                /    
* --------  ----           ---          -----------
* inode     struct inode*  input        ļڵṹ
* filp      struct file*   input        ļṹ
* ֵ:
* 0       ɹ
* ˵
*******************************************************************************/
int mem_bsp_open(struct inode *inode, struct file *filp)
{
    return 0;
}

/*******************************************************************************
* : ad9731_bsp_release
* : رļ
* ĵ:
* 洢:int
* :
*
*                /    
* --------  ----           ---          -----------
* inode     struct inode*  input        ļڵṹ
* filp      struct file*   input        ļṹ
* ֵ:
* 0       ɹ
* ˵
*******************************************************************************/
int mem_bsp_release(struct inode *inode, struct file *filp)
{
    /* ɹ */
    return 0;
}

/*******************************************************************************
* : ad9731_bsp_read ()
*
* :  
* ĵ: <˺Эơ汾Эеλ>
* 洢:

*******************************************************************************/
static ssize_t mem_bsp_read (struct file *filp, char *buf, size_t count, loff_t *f_pos)
{
    return 0;
}

/*******************************************************************************
* : ad9731_bsp_write ()
*
* : д
* ĵ: <˺Эơ汾Эеλ>
* 洢:

*******************************************************************************/
ssize_t mem_bsp_write(struct file *filp, const char *buf, size_t count, loff_t *f_pos)
{
    return 0;
}

/*******************************************************************************
* : ad9731_bsp_ioctl
* : IO
* ĵ:
* 洢:int
* :

*******************************************************************************/
long mem_bsp_ioctl(struct file *filp, unsigned int cmd, unsigned long arg)
{
   return 0;
}

/*******************************************************************************
* : mem_bsp_mmap
* : IOڴӳ
* ĵ:
* 洢:int
* :
*
*******************************************************************************/

int mem_bsp_mmap(struct file *filp, struct vm_area_struct *vma)
{
    /* IO־ */

    vma->vm_flags |= VM_IO;


	vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
	printk("mmap start\n\r");

    /* ӳ */
    if (remap_pfn_range(vma,
                vma->vm_start,
                vma->vm_pgoff,
                vma->vm_end-vma->vm_start,
                vma->vm_page_prot) < 0)
    {
        return -EAGAIN;
    }

    return 0;
}


MODULE_AUTHOR       ("mr yang");
MODULE_DESCRIPTION  ("mem_dump" );
MODULE_LICENSE      ("GPL");
module_init(osp_mem_init); 
module_exit(osp_mem_exit);

/******************************* Դļ ***********************************/

